package com.huimv.video.dhicc.test.request.XunZhengRequest.Hn;

import com.alibaba.fastjson.JSON;
import com.huimv.video.dhicc.icc.CommonConstant;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo02;
import com.huimv.video.dhicc.test.constant.Constant;
import com.huimv.video.dhicc.test.request.BaseRequest02;
import com.huimv.video.dhicc.test.utils.HttpURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.HttpsURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.UrlUtil;
import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class XunZhengRequestHn extends BaseRequest02 {

    private Integer farmId;

    private Integer pageNum;

    private Integer pageSize;

    private String alarmStartDateString;

    private String alarmEndDateString;

    private Integer eventType;

    public XunZhengRequestHn(){
    }

    public XunZhengRequestHn(OauthConfigBaseInfo02 oauthConfigBaseInfo){
        super(oauthConfigBaseInfo, Constant.HTTP_POST,oauthConfigBaseInfo.getHttpConfigInfo().getPrefixUrl() + Constant.EVENT_URL, true);
    }

    @Override
    public String doAction() {
        //重置url信息，替换版本号
        this.setUrl(UrlUtil.dealVersion(this.getUrl()));
        //设置请求参数
        setBody();
        //发送请求
        String res = isEnableHttpTest() ? HttpURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader()) : HttpsURLConnectionUtil.doPost(this.getUrl(), this.getBody(), this.getHeader());
        //获取响应

        // PersonListResponseSg devicePageResponse = JSON.parseObject(res, PersonListResponseSg.class);

        return res;
    }

    private void setBody() {
        //设置请求参数
        Map<String, Object> map = new HashMap<>();
        map.put("pageNum", this.pageNum);
        map.put("pageSize", this.pageSize);
        map.put("alarmStartDateString", this.alarmStartDateString);
        map.put("alarmEndDateString", this.alarmEndDateString);
        map.put("alarmType", 303);
        map.put("dbType", 0);
        map.put("deviceCategory", 1);
        //nodeCodeList 目前还没有 先用曙光的
        if (this.eventType == 1){
            map.put("nodeCodeList", CommonConstant.Sg_SiZhuChannle);
        }else if (this.eventType == 2){
            map.put("nodeCodeList", CommonConstant.Sg_DoorChannle);
        }else if (this.eventType == 3){
            map.put("nodeCodeList", CommonConstant.Sg_XunZhengChannle);
        }else {
            map.put("nodeCodeList", CommonConstant.Sh_MaiZhuChannle);
        }
        this.setBody(JSON.toJSONString(map));

    }

    public boolean isEnableHttpTest() {
        return super.getOauthConfigBaseInfo().getHttpConfigInfo().isEnableHttpTest();
    }
}
